unit MyObjects;

interface

uses
  Classes, Generics.Defaults, Generics.Collections;

type
  TKid = class
    FirstName: String;
    LastName: String;
    Age: Integer;
    BornDate: TDateTime;
    class function CreateAndInitialize: TKid;
  end;

  TTeenager = class(TKid)
    Phones: TStringList;
    constructor Create; virtual;
    destructor Destroy; virtual;
    class function CreateAndInitialize: TTeenager;
  end;


  TLaptop = class
    Model: String;
    Price: Currency;
    constructor Create(AModel: String; APrice: Currency);
  end;
  TLaptops = TObjectList<TLaptop>;

  TProgrammer = class(TTeenager)
    Laptops: TLaptops;
    constructor Create; override;
    destructor Destroy; override;
    class function CreateAndInitialize: TProgrammer;
  end;


implementation

uses
  SysUtils;

{ TKid }

class function TKid.CreateAndInitialize: TKid;
begin
  Result := TKid.Create;
  Result.FirstName := 'Daniele';
  Result.LastName := 'Teti';
  Result.Age := 29;
  Result.BornDate := encodedate(1979,11,4);
end;

{ TTeenager }

constructor TTeenager.Create;
begin
  inherited;
  Phones := TStringList.Create;
end;

class function TTeenager.CreateAndInitialize: TTeenager;
begin
  Result := TTeenager.Create;
  Result.FirstName := 'Daniele';
  Result.LastName := 'Teti';
  Result.Age := 29;
  Result.BornDate := encodedate(1979,11,4);
  Result.Phones.Add('NUMBER01');
  Result.Phones.Add('NUMBER02');
  Result.Phones.Add('NUMBER03');
end;

destructor TTeenager.Destroy;
begin
  Phones.Free;
  inherited;
end;

{ TProgrammer }

constructor TProgrammer.Create;
begin
  inherited;
  Laptops := TLaptops.Create;
end;

class function TProgrammer.CreateAndInitialize: TProgrammer;
begin
  Result := TProgrammer.Create;
  Result.FirstName := 'Daniele';
  Result.LastName := 'Teti';
  Result.Age := 29;
  Result.BornDate := encodedate(1979,11,4);
  Result.Phones.Add('NUMBER01');
  Result.Phones.Add('NUMBER02');
  Result.Phones.Add('NUMBER03');
  Result.Laptops.Add(TLaptop.Create('HP Presario C700', 1000));
  Result.Laptops.Add(TLaptop.Create('Toshiba Satellite Pro', 800));
  Result.Laptops.Add(TLaptop.Create('IBM Travelmate 500', 1300));
end;

destructor TProgrammer.Destroy;
begin
  Laptops.Free;
  inherited;
end;

{ TLaptop }

constructor TLaptop.Create(AModel: String; APrice: Currency);
begin
  inherited Create;
  Model := AModel;
  Price := APrice;
end;



end.
